using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;
using J4L.Vision;


/// <summary>
/// Description of MainForm.
/// </summary>
public class Sample
{
		
		
private string[][] testSet={new string[] {"ima_300dpi_90.png",""+Barcode1DReader.CODE128},
new string[] {"ean128_5_4.png",""+Barcode1DReader.CODE128},
new string[] {"ean128_90_2.png",""+Barcode1DReader.CODE128},
new string[] {"ean128_90_1.GIF",""+Barcode1DReader.CODE128},
new string[] {"ean128_266_3.png",""+Barcode1DReader.CODE128},
new string[] {"ean128_111_3.png",""+Barcode1DReader.CODE128}, 
new string[] {"ean128_10_2.png",""+Barcode1DReader.CODE128},
new string[] {"ean128_0_2.png",""+Barcode1DReader.CODE128},	
new string[] {"ean128_45_4.png",""+Barcode1DReader.CODE128},	
new string[] {"ean128_45_3.png",""+Barcode1DReader.CODE128},	
new string[] {"ean128_30_3.png",""+Barcode1DReader.CODE128},
new string[] {"ean128_60_3.png",""+Barcode1DReader.CODE128},	
new string[] {"ean13_0_3.png",""+Barcode1DReader.EAN13},	
new string[] {"ean8.png",""+Barcode1DReader.EAN8},	
new string[] {"upca.png",""+Barcode1DReader.UPCA},	
new string[] {"upce.png",""+Barcode1DReader.UPCE},	
new string[] {"upce_2.png",""+Barcode1DReader.UPCE},	
new string[] {"code39.png",""+Barcode1DReader.CODE39},
new string[] {"scan_ean1.gif",""+Barcode1DReader.EAN13},
new string[] {"scan_ean2.png",""+Barcode1DReader.EAN13},
new string[] {"identcode.PNG",""+Barcode1DReader.IDENTCODE},
new string[] {"scan_ean4.png",""+Barcode1DReader.EAN13},
new string[] {"ean13_shoe.png",""+Barcode1DReader.EAN13},
//new string[] {"ean8_scan1_2.png",""+Barcode1DReader.EAN8},
//new string[] {"ean8_bag.png",""+Barcode1DReader.EAN8},
new string[] {"i25.png",""+Barcode1DReader.INTERLEAVED25},
new string[] {"barcode_scan7_i125.png",""+Barcode1DReader.INTERLEAVED25},
new string[] {"barcode_scan3_code128.png",""+Barcode1DReader.CODE128},
new string[] {"barcode_scan5_ean13.png",""+Barcode1DReader.EAN13},
new string[] {"barcode_scan_code39.png",""+Barcode1DReader.CODE39}};
		
	private String dir="images\\";
		
		
		
	/**
	 * read all test files
	 *
	 */
	public void runTests() {		
	 	for (int i=0;i<testSet.GetLength(0);i++) {
			try {
				
				Console.WriteLine("");
				Console.WriteLine("------------------------------");
				Console.WriteLine("Scanning File: "+testSet[i][0]);
				Console.WriteLine("");
				scanImage(testSet[i][0],Convert.ToInt32(testSet[i][1]));
				Console.WriteLine("------------------------------");
			} catch (Exception e) {
	 			Console.WriteLine(e.Message);
	 			Console.WriteLine(e.StackTrace);
			}
		}		
	}	
	 
	public void scanImage(String file,int type) {
	 	
	 	
	 	
	 	Bitmap im=(Bitmap) loadImage(dir+file);
		

		Barcode1DReader reader=new Barcode1DReader();
	 	Console.WriteLine("Start "+DateTime.Now);
		reader.setSymbologies(type);
		
		//J4L.Vision.Util.Histogram h=new J4L.Vision.Util.Histogram(new RImage(im));
		
		BarcodeData[] barcodes=reader.scan(new RImage(im));
		
		if (barcodes.GetLength(0)==0) Console.WriteLine("*** NO BARCODE FOUND ***");
		
		Console.WriteLine("End "+DateTime.Now);		
		
		for (int i=0;i<barcodes.GetLength(0);i++) {
			Console.WriteLine("Barcode  found "+barcodes[i].ToString());
			
		}
		
	}
	
	/**
	 * load image from file
	 */
	public Image loadImage(String f) {
			
	 	Image bp= Bitmap.FromFile(f);
	 	Bitmap b2=new Bitmap(bp.Width,bp.Height,PixelFormat.Format24bppRgb);
	 	Graphics g=Graphics.FromImage(b2);
	 	g.DrawImage(bp,0,0);
	 	g.Dispose();
	 	return b2;

	}		 
		
	[STAThread]
	public static void Main(string[] args)
	{
		Sample sample=new Sample();
		J4L.Vision.Util.SystemProperties.registerAppArgs(args);		
		//sample.scanImage("ean8_scan1_2.png",Barcode1DReader.EAN8);
		//sample.scanImage("ean8_bag.png",Barcode1DReader.EAN8);
		
		sample.runTests();
	}
		

}
